/* DatabaseManager.h created by ahoesch on Thu 05-Apr-2001 */

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import "FBConnectionController.h"

@protocol DBCPageViewControllerProtocol

- (NSString *)title;
- (NSView *)pageView;
- (void)activate;
- (void)deactivate;

@end

@interface DatabaseManager : FBConnectionController
{
   IBOutlet NSWindow *mainWin;
   IBOutlet NSTabView *tabView;
   NSMutableArray *_pageViewControllers;
   id < DBCPageViewControllerProtocol > _currentManager;
}

- (id)initWithDatabaseController:(FBDatabaseController *)aController;

- (void)addPageViewController:(id < DBCPageViewControllerProtocol >)controller;

- (void)createTabViewItems;

@end
