/* ConnectionController.h created by ahoesch on Fri 26-Jan-2001 */
#import <AppKit/AppKit.h>
#import <FBEnterprise/FBEnterprise.h>
#import <FBObjects/FBObjects.h>

@class FBDatabaseController;
@class FBWindowController;
@class FBMetaController;

#define ConnectionControllerActivatedNotification @"ConnectionControllerActivatedNotification"

@interface FBConnectionController : NSObject
{
   FBDatabaseController *_databaseController;
   FBMetaController *_metaController;
   NSMutableArray *_windowControllers;
   OBModel *_obmodel;
   FBModel *_fbmodel;
   NSString *_hostname;
   NSString *_database;
   NSString *_port;
   NSString *_username;
   NSString *_password;
   NSString *_databasePassword;
}

/* *** init *** */
+ (id)connectionWithDatabaseController:(FBDatabaseController *)aController;
- (id)initWithDatabaseController:(FBDatabaseController *)aController;
- (id)initWithDatabaseController:(FBDatabaseController *)aController forceSystem:(BOOL)flag;

- (BOOL)isSystemSession;
- (void)shutdown;

/* **************************************
   databaseController
   ************************************** */
- (void)setDatabaseController:(FBDatabaseController *)databaseController;
- (FBDatabaseController *)databaseController;

/* **************************************
   metaController
   ************************************** */
- (FBMetaController *)metaController;
- (void)createMetaController;

/* **************************************
   windowController
   ************************************** */
- (void)addWindowController:(FBWindowController *)windowController;
- (void)removeWindowController:(FBWindowController *)windowController;
- (void)removeAllWindowControllers;

/* **************************************
   model
   ************************************** */
- (BOOL)readModel;
- (BOOL)writeModel;
- (OBModel *)obmodel;
- (FBModel *)fbmodel;
- (BOOL)readFromFile:(NSString *)path;
- (void)invalidateFBModel;

/* **************************************
   window
   ************************************** */
- (void)showMainWin;

@end
