/* FBDatabasesManager.h created by ahoesch on Thu 13-Apr-2000 */
#import <AppKit/AppKit.h>

@class FBDatabaseController;

/*@interface NSString (NumericAddress)

- (BOOL)looksLikeNumericAddress;

@end*/

@interface FBDatabasesManager : NSObject
{
   NSMutableDictionary *_hostControllerDic; // hostname --> FBHostController
}

+ (id)sharedManager;

- (BOOL)addMonitoredHost:(NSString *)aHostname;
- (void)removeMonitoredHost:(NSString *)aHostName;
- (NSArray *)monitoredHosts;

- (BOOL)addMonitoredDatabases:(NSArray *)aArray onHost:(NSString *)aHostname;
- (BOOL)addMonitoredDatabase:(NSString *)aDatabase onHost:(NSString *)aHostname;
- (BOOL)addMonitoredDatabase:(NSString *)aDatabase onHost:(NSString *)aHostname withOptions:(NSString *)aString;
- (void)removeMonitoredDatabase:(NSString *)aDatabase fromHost:(NSString *)aHostname;
- (NSArray *)monitoredDatabasesOnHost:(NSString *)aHostname;
- (NSArray *)databaseControllers;

- (void)createDatabase:(NSString *)aDatabase onHost:(NSString *)aHostname;
- (void)createDatabase:(NSString *)aDatabase onHost:(NSString *)aHostname withOptions:(NSString *)aString;
- (NSArray *)availableDatabasesOnHost:(NSString *)aHostname;
- (NSArray *)availableDatabasesOnHost:(NSString *)aHostname showAll:(BOOL)flag;

- (void)writeMonitoredDatabasesToDefaults;
- (void)readMonitoredDatabasesFromDefaults;

- (FBDatabaseController *)databaseControllerForDatabase:(NSString *)database host:(NSString *)hostname;

@end
