/* FBHostController.h created by ahoesch on Fri 27-Sep-2002 */

#import <Foundation/Foundation.h>

@class FBDatabaseController;

@interface FBHostController : NSObject
{
   NSString *_hostname;
   NSMutableDictionary *_databaseControllerDic; // databaseName --> databaseController
   FBExecHandler *_exec;
}

+ (void)removePasswordForHost:(NSString *)host;
+ (NSString *)passwordForHost:(NSString *)host;

- (id)initWithHost:(NSString *)aHostname;

- (NSString *)hostname;
- (void)createDatabase:(NSString *)aDatabase withOptions:(NSString *)optionString;
- (void)addMonitoredDatabase:(NSString *)aDatabase withOptions:(NSString *)optionString;
- (void)removeMonitoredDatabase:(NSString *)aDatabase;
- (NSArray *)monitoredDatabases;
- (NSArray *)databaseControllers;

- (NSArray *)allAvailableDatabases;
- (NSArray *)availableDatabases;
- (FBDatabaseController *)databaseControllerForDatabaseNamed:(NSString *)database;

@end
