/* FBItemView.h created by ahoesch on Thu 12-Apr-2001 */
#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

#define ContainerViewSelectionDidChangeNotification @"ContainerViewSelectionDidChangeNotification"

@class FBContainerView;

@protocol FBItemViewItemProtocol

- (NSString *)itemTitle;
- (NSImage *)itemImage;
- (void)itemDoubleClicked;

@end

@interface FBItemView : NSView
{
   NSActionCell *_txtCell, *_imgCell;
   NSRect _txtFrame, _imgFrame, _bckFrame;
   BOOL _selected;
   id < FBItemViewItemProtocol > _item;
}

- (id)initWithItem:(id < FBItemViewItemProtocol >)item;
- (id < FBItemViewItemProtocol >)item;

- (FBContainerView *)containerView;

- (void)updateFrameSize;
- (void)setFrameSize;
- (void)setSelected:(BOOL)flag;
- (BOOL)isSelected;

- (NSString *)itemTitle;
- (NSImage *)itemImage;

@end
