/* FBMetaController.h created by ahoesch on Tue 08-Oct-2002 */
#import <Foundation/Foundation.h>
#import <FBEnterprise/FBEnterprise.h>

#define META_SCHEMA @"META"
#define DATA_SCHEMA @"_SYSTEM"

typedef enum { COCOA_MACOSX, GNUSTEP_SOLARIS } PLATFORM_IDENT;

@interface FBMetaController : NSObject
{
   FBEditingContext *_editingContext;
   NSString *_user;
   NSString *_password;
   NSString *_databaseIdent;
   BOOL _isSystemSession;
}

- (id)initWithHost:(NSString *)hostname database:(NSString *)database port:(NSString *)port username:(NSString *)username password:(NSString *)password databasePassword:(NSString *)databasePassword;

- (id)initWithHost:(NSString *)hostname database:(NSString *)database port:(NSString *)port username:(NSString *)username password:(NSString *)password databasePassword:(NSString *)databasePassword model:(NSString *)modelName;

- (FBEditingContext *)editingContext;
- (NSDictionary *)connectionDictionary;
- (BOOL)isSystemSession;
- (NSString *)currentUser;
- (void)executeStatements:(NSArray *)array;
- (BOOL)secureExistenceOfMetaTables;

/* **************************************
   group
   ************************************** */
- (void)addGroup:(NSString *)groupName;
- (void)removeGroup:(NSString *)groupName;
- (NSArray *)groups;

/* **************************************
   user
   ************************************** */
- (void)addUser:(NSString *)userName;
- (void)removeUser:(NSString *)userName;
- (NSArray *)users;

- (void)setDefaultGroup:(NSString *)groupName forUser:(NSString *)username;
- (NSString *)defaultGroupForUser:(NSString *)username;

- (void)setDefaultPrivileges:(NSString *)privileges user:(NSString *)username tables:(NSArray *)tableNames;
- (NSNumber *)defaultPrivilegesForUser:(NSString *)username tableName:(NSString *)tableName;

- (void)setPassword:(NSString *)password forUser:(NSString *)username;

/* **************************************
   member
   ************************************** */
- (void)addMember:(NSString *)username toGroup:(NSString *)groupName;
- (void)removeMember:(NSString *)username fromGroup:(NSString *)groupName;
- (NSArray *)membersOfGroup:(NSString *)groupName;

/* **************************************
   obmodel
   ************************************** */
- (BOOL)setOBModelPropertyList:(NSArray *)propertyList allowDestruction:(BOOL)flag;
- (BOOL)setOBModelPropertyList:(NSArray *)propertyList;
- (NSArray *)obmodelPropertyList;
- (NSCalendarDate *)propertyListDate;
- (BOOL)requiresModifications:(NSArray *)propertyList allowDestruction:(BOOL)flag;

/* **************************************
   classBundle
   ************************************** */
- (void)setClassesBundleFromPath:(NSString *)path forPlatform:(PLATFORM_IDENT)platformIdent;
- (void)setClassesBundle:(NSData *)data forPlatform:(PLATFORM_IDENT)platformIdent;
- (NSData *)classesBundleForPlatform:(PLATFORM_IDENT)platform;
- (NSCalendarDate *)classesBundleDateForPlatform:(PLATFORM_IDENT)platformIdent;

@end
