/* FBTableViewAssociation.h created by ahoesch on Tue 19-Dec-2000 */

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import "FBAssociation.h"

@class FBColumnAssociation;

@protocol TableCellManagerProtocol

- (void)tableView:(NSTableView *)tybleView willDisplayCell:(id)cell forTableColumn:(NSTableColumn *)tableColumn object:(FBObject *)object;

@end

@interface FBTableViewAssociation : FBAssociation
{
   NSMutableDictionary *_columnAssociationDic;
   id < TableCellManagerProtocol > _tableCellManager;
   BOOL _editingContextEditable;
   BOOL _enterCellInFirstColumnWhenChangingSelection;
}

- (void)checkSelection;

- (void)setEditingContextEditable:(BOOL)flag;
- (void)setColumnAssociation:(FBColumnAssociation *)association forIdentifier:(NSString *)identfier;
- (void)setTableCellManager:(id < TableCellManagerProtocol >)delegate;
- (void)enterCellWhenChangingSelection;
- (BOOL)isDeleteEnabled;
- (void)populateSelectionToDisplayGroup;

@end

@interface NSTableView (NSTableViewAssociationExtension)

- (void)bindToDisplayGroup:(FBDisplayGroup *)displayGroup editable:(BOOL)flag;
- (void)destroyAssociations;

@end
