/* FBWindowController.h created by ahoesch on Fri 27-Sep-2002 */

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import <FBEnterprise/FBEnterprise.h>

@class FBConnectionController;

@interface FBWindowController : NSObject
{
   IBOutlet NSWindow *mainWin;
   FBConnectionController *_connectionController;
   FBEditingContext *_editingContext;
   BOOL _windowCloseEnabled;
}

- (id)initWithNibNamed:(NSString *)nibName;

- (void)createEditingContext;
- (FBEditingContext *)editingContext;

- (BOOL)save;
- (void)shutdown;
- (void)positionWindow;

/* **************************************
   connectionController
   ************************************** */
- (void)setConnectionController:(FBConnectionController *)connectionController;
- (FBConnectionController *)connectionController;

/* **************************************
   window
   ************************************** */
- (void)setDocumentEdited:(BOOL)flag;
- (BOOL)isDocumentEdited;

- (void)showMainWin;
- (NSWindow *)mainWin;

@end
