/* InspectorController.h created by ahoesch on Fri 08-Dec-2000 */

#import <AppKit/AppKit.h>

@protocol InspectorProtocol

- (NSView *)inspectorView;
- (void)activateClient:(id)client;
- (id)client;
- (void)deactivate;

- (void)showFirstPage;
- (void)showSecondPage;

- (void)showPageWithTag:(int)tag;
- (int)tagOfCurrentPage;

@end

@interface InspectorController : NSObject
{
   IBOutlet NSPanel *panel;
   IBOutlet NSBox *noInspectorBox;
   NSMutableDictionary *_controllerDic;
   id <InspectorProtocol> _currentInspector;
}

+ (InspectorController *)controller;
- (void)show;

- (void)registerInspectorControllerClass:(NSString *)aInspectorClass forClass:(NSString *)aClientClass;
- (id)controllerForClient:(id)aClient;
- (void)activateClient:(id)aClient;
- (void)activateClient:(id)aClient userInfo:(NSDictionary *)userInfo;
- (id)client;

- (void)showFirstPage;
- (void)showSecondPage;

- (id)targetForAction:(SEL)selector;
- (void)setMinSize:(NSSize)size;

@end
