/* PreferencesController.h created by ahoesch on Thu 04-Jan-2001 */

#import <AppKit/AppKit.h>

@protocol PreferencesPageProtocol

- (NSString *)title;
- (NSView *)pageView;
- (void)preferencesDidBecomeKey;
- (void)preferencesDidResignKey;
- (void)registerDefaults:(NSMutableDictionary *)appDefaults;

@end


@interface PreferencesController : NSObject
{
   IBOutlet NSWindow *mainWin;
   IBOutlet NSBox *box;
   IBOutlet NSPopUpButton *popUp;
   NSMutableArray *_pages;
}

+ (id)sharedController;

- (void)addPage:(id < PreferencesPageProtocol >)page;

- (void)showMainWin:(id)sender;
- (void)setContents:(id)sender;

// should be called after all preferences pages have been added
- (void)registerDefaults;
- (void)setDefaults:(id)sender;
- (void)setMinSize:(NSSize)size;

@end

