/* PrintManager.h created by ahoesch on Wed 05-Dec-2001 */

#import <Foundation/Foundation.h>
#import <FBEnterprise/FBEnterprise.h>

typedef enum { MEDIUM_FAX, MEDIUM_LETTER } PRINT_MEDIUM;

//@protocol PrintableObjectProtocol

// LaTeX template
//- (NSString *)latexResource;

// sdletter.cls, greekbib.sty...
//- (NSArray *)otherResources;

// Logo.pdf --> wrapper
//- (NSDictionary *)wrapperDic;

//@end

@interface PrintManager : NSObject
{

}

//+ (NSString *)printObject:(FBObject *)object script:(NSString *)script;
+ (NSString *)printObject:(NSObject *)object script:(NSString *)script name:(NSString *)name;
+ (NSString *)exportObject:(NSObject *)object name:(NSString *)name extension:(NSString *)extension;

@end

@interface NSObject (PrintableObjectExtension)

// If none of the following methods is overwritten <class>___fax or <class>___letter is used

// e.g. AdvancedScience, SmartsoftGmbH,...
- (NSString *)printResourceIdentifier;

// e.g. GermanVat, EnglishNoVat
- (NSString *)printResourceKind;

- (NSDictionary *)printResourceKindWrapperDic;

- (NSString *)printWithSuffix:(NSString *)suffix;
- (NSString *)exportWithSuffix:(NSString *)suffix extension:(NSString *)extension;

@end
