/* FBArrayExtension.h created by ahoesch on Tue 26-Sep-2000 */

#import <Foundation/Foundation.h>

@class FBQualifier;

@interface FBSortOrdering : NSObject
{
   BOOL ascending;
   NSString *key;
}

+ (id)sortOrderingWithKey:(NSString *)aKey ascending:(BOOL)flag;
- (id)initWithKey:(NSString *)aKey ascending:(BOOL)flag;
- (NSString *)key;
- (BOOL)ascending;

@end

@interface NSArray (FBArraySorting)

- (NSArray *)sortedArrayUsingSortOrderings:(NSArray *)keyOrderArray;
- (BOOL)exchange:(id)object1 and:(id)object2 keyOrderArray:(NSArray *)keyOrderArray;

@end

@interface NSArray (FBArrayAccess)

- (NSArray *)arrayByRemovingLastObject;
- (NSArray *)arrayByRemovingObjectsInArray:(NSArray *)otherArray;
- (NSArray *)unionArrayWithObjects:(NSArray *)array;
- (void)makeObjectsPerformSelector:(SEL)aSelector withObject:(id)argumentA withObject:(id)argumentB;
- (id)valueForKey:(NSString *)aKey;
- (id)valueForKey:(NSString *)aKey allowArray:(BOOL)flag;
- (id)objectWithStringValue:(NSString *)value forKey:(NSString *)aKey;
- (id)firstObject;
- (NSArray *)arrayByDeletingLastObject;
- (NSArray *)arrayForIndexes:(NSArray *)indexes;
- (NSArray *)indexesOfObjects:(NSArray *)objects;
- (NSArray *)filteredArrayUsingQualifier:(FBQualifier *)qualifier;
- (NSArray *)arrayByExtractingObjectsToIndex:(int)index;
- (NSArray *)arrayContainingObjects:(NSArray *)array;

- (BOOL)containsAllObjectsFromArray:(NSArray *)array;
- (BOOL)containsAtLeastOneObjectFromArray:(NSArray *)array;


@end

