/* FBAttribute.h created by ahoesch on Sat 30-Sep-2000 */

#import <Foundation/Foundation.h>

@class FBEntity;

#define USERINFOKEY_IDENTIFIER @"identifier"
#define USERINFOKEY_QUOTE @"quote"

@interface FBAttribute : NSObject < NSCoding >
{
   NSString *_name;
   FBEntity *_entity;
   NSString *_externalType;
   NSString *_columnName;
   NSMutableArray *_definitionArray;
   NSString *_valueClassName;
   NSString *_valueType;
   NSString *_readFormat;
   NSString *_writeFormat;
   NSString *_factoryMethodName;
   NSString *_conversionMethodName;
   unsigned int _width;
   unsigned short _precision;
   short _scale;
   BOOL _allowsNull;
   BOOL _isReadOnly;
   BOOL _isFlattened;
   NSDictionary *_userInfo;
}

- (NSDictionary *)propertyList;


- (void)setName:(NSString *)name;
- (NSString *)name;

- (void)setEntity:(FBEntity *)entity;
- (FBEntity *)entity;

- (void)setExternalType:(NSString *)type;
- (NSString *)externalType;

- (void)setColumnName:(NSString *)columnName;
- (NSString *)columnName;

- (void)setValueFactoryMethodName:(NSString *)factoryMethodName;
- (NSString *)valueFactoryMethodName;
- (SEL)valueFactoryMethod;

- (void)setAdaptorValueConversionMethodName:(NSString *)conversionMethodName;
- (NSString *)adaptorValueConversionMethodName;
- (SEL)adaptorValueConversionMethod;

- (id)adaptorValueByConvertingAttributeValue:(id)value;

- (void)setDefinition:(NSString *)definition;
- (NSString *)definition;

- (BOOL)isFlattened;
- (BOOL)isDerived;
- (BOOL)isPrimaryKey;

- (void)setReadOnly:(BOOL)yn;
- (BOOL)isReadOnly;

- (void)setValueClassName:(NSString *)name;
- (NSString *)valueClassName;

- (void)setValueType:(NSString *)type;
- (NSString *)valueType;

- (void)setWidth:(unsigned)length;
- (unsigned)width;

- (void)setPrecision:(unsigned)precision;
- (unsigned)precision;

- (void)setScale:(int)scale;
- (int)scale;

- (void)setAllowsNull:(BOOL)allowsNull;
- (BOOL)allowsNull;

- (void)setWriteFormat:(NSString *)string;
- (NSString *)writeFormat;
- (void)setReadFormat:(NSString *)string;
- (NSString *)readFormat;

- (void)setUserInfo:(NSDictionary *)dictionary;
- (NSDictionary *)userInfo;

@end
