/* FBDataSource.h created by ahoesch on Wed 13-Dec-2000 */

#import <Foundation/Foundation.h>

@class FBEditingContext;
@class FBObject;
@class FBEntity;
@class FBQualifier;

@interface FBDataSource : NSObject
{
   FBEditingContext *_editingContext;
   NSMutableDictionary *_detailDataSourcesDic;
   FBQualifier *_qualifier;
}

- (id)initWithEditingContext:(FBEditingContext *)editingContext;

- (FBEditingContext *)editingContext;
- (FBEntity *)entity;

- (NSArray *)fetchObjects;
- (NSArray *)fetchObjectsWithSortOrderings:(NSArray *)sortOrderings;
- (FBObject *)createObject;
- (BOOL)insertObject:(id)object;
- (BOOL)deleteObject:(FBObject *)object;

- (void)setQualifier:(FBQualifier *)qualifier;
- (FBQualifier *)qualifier;

- (void)qualifyWithObject:(FBObject *)masterObject;
- (FBDataSource *)dataSourceQualifiedByKey:(NSString *)relationshipKey;

- (void)setAuxiliaryQualifier:(FBQualifier *)qualifier;
- (FBQualifier *)auxiliaryQualifier;

- (BOOL)shouldDeleteObjects:(NSArray *)objects;
- (BOOL)isQualifyingDatabaseDataSource;

@end
