/* FBFetchSpecification.h created by ahoesch on Tue 26-Sep-2000 */

#import <Foundation/Foundation.h>
#import "FBQualifier.h"

@interface FBFetchSpecification : NSObject
{
   NSString *_entityName;
   FBQualifier *_qualifier;
   NSArray *_sortOrderings;
   BOOL _isExpandable;
   NSRange _range;
   NSString *_detailKey;
}

+ (id)fetchSpecificationWithEntityName:(NSString *)entityName qualifier:(FBQualifier *)qualifier sortOrderings:(NSArray *)sortOrderings;
+ (id)fetchSpecificationWithEntityName:(NSString *)entityName qualifier:(FBQualifier *)qualifier sortOrderings:(NSArray *)sortOrderings detailKey:(NSString *)detailKey;
+ (id)fetchSpecificationWithEntityName:(NSString *)entityName qualifier:(FBQualifier *)qualifier sortOrderings:(NSArray *)sortOrderings detailKey:(NSString *)detailKey expandable:(BOOL)expandable;

- (id)initWithEntityName:(NSString *)entityName qualifier:(FBQualifier *)qualifier sortOrderings:(NSArray *)sortOrderings;
- (id)initWithEntityName:(NSString *)entityName qualifier:(FBQualifier *)qualifier sortOrderings:(NSArray *)sortOrderings detailKey:(NSString *)detailKey expandable:(BOOL)expandable;

- (NSString *)entityName;
- (NSString *)detailKey;
- (FBQualifier *)qualifier;
- (FBQualifier *)originalQualifier;
- (NSArray *)sortOrderings;
- (BOOL)isExpandable;

- (FBFetchSpecification *)expandedFetchSpecificationWithMargin:(unsigned int)margin range:(NSRange *)pRange;

@end

@interface FBUnionFetchSpecification : FBFetchSpecification
{
   NSArray *_fetchSpecifications;
}

+ (id)fetchSpecificationWithFetchSpecifications:(NSArray *)array;
- (id)initWithFetchSpecifications:(NSArray *)array;
- (NSArray *)fetchSpecifications;

@end
