/* FBGlobalID.h created by ahoesch on Thu 12-Oct-2000 */

#import <Foundation/Foundation.h>

@class FBObject;

@interface FBEntityManager : NSObject
{
   NSMutableArray *_entities;
}

+ (id)manager;

- (int)identifierForEntityName:(NSString *)entityName;
- (NSString *)entityNameForIdentifier:(int)identifier;

@end


// is only good for identifiying objects within one process, otherwise use FBObjectID
@interface FBGlobalID : NSObject <NSCopying, NSCoding>
{
   int _identifier; // entity
   int _primaryKey1;
   int _primaryKey2;
}

+ (id)globalIDForObject:(FBObject *)object;
+ (id)globalIDWithIdentifier:(int)identifier primaryKey:(int)primaryKey;
+ (id)globalIDWithIdentifier:(int)identifier primaryKeys:(NSArray *)primaryKeys;

- (id)initWithIdentifier:(int)identifier primaryKey:(int)primaryKey;
- (id)initWithIdentifier:(int)identifier primaryKey1:(int)primaryKey1 primaryKey2:(int)primaryKey2;
- (id)initWithIdentifier:(int)identifier primaryKeys:(NSArray *)primaryKeys;

- (int)identifier;
- (int)primaryKey;
- (int)primaryKey1;
- (int)primaryKey2;

- (BOOL)isTemporary;
- (NSString *)entityName;

@end

@interface FBTemporaryGlobalID : FBGlobalID
{
   NSString *_temporaryKey;
}

- (id)initWithTemporaryKey:(NSString *)temporaryKey;
- (NSString *)temporaryKey;

@end
