/* FBModel.h created by ahoesch on Sat 30-Sep-2000 */

#import <Foundation/Foundation.h>
#import "FBEntity.h"

@interface FBModel : NSObject < NSCoding >
{
   NSString *_path, *_name,*_adaptorName;
   NSMutableDictionary *_entityDic; // name --> FBEntity
   NSMutableDictionary *_connectionDic;
   NSDictionary *_userInfo;
}

+ (NSArray *)deleteRuleStrings;
+ (NSArray *)joinSemanticStrings;

- (id)initWithModelName:(NSString *)modelName;
- (id)initWithModelName:(NSString *)modelName ignoreTables:(BOOL)flag;
- (id)initWithPath:(NSString *)path;

- (id)initWithPropertyList:(NSDictionary *)propertyList;
- (NSDictionary *)propertyList;

- (BOOL)readModelNamed:(NSString *)modelName collector:(NSMutableDictionary *)collector ignoreTables:(BOOL)flag;
- (BOOL)readModelWithPath:(NSString *)modelPath collector:(NSMutableDictionary *)collector ignoreTables:(BOOL)flag;

//- (BOOL)readModelNamed:(NSString *)modelName;
- (BOOL)writeToFile:(NSString *)path;
- (NSArray *)entitiesForIndexFile;
- (NSString *)path;
- (NSString *)adaptorName;

- (BOOL)initializeFromPropertyList:(NSDictionary *)propertyList;
- (NSDictionary *)indexFileProperties;

- (void)addEntity:(FBEntity *)entity;
- (void)removeEntity:(FBEntity *)entity;
- (void)removeEntityAndReferences:(FBEntity *)entity;
- (NSArray *)entityNames;
- (FBEntity *)entityNamed:(NSString *)name;
- (NSArray *)tableEntities;
- (NSArray *)entities;

- (void)setName:(NSString *)name;
- (NSString *)name;

- (void)setUserName:(NSString *)username;
- (void)setPassword:(NSString *)password;
- (void)setSessionName:(NSString *)sessionName;

- (void)setConnectionDictionary:(NSDictionary *)connectionDictionary;
- (NSDictionary *)connectionDictionary;

- (void)setHost:(NSString *)host database:(NSString *)database port:(NSString *)port username:(NSString *)username password:(NSString *)password databasePassword:(NSString *)databasePassword;

- (NSString *)username;
- (NSString *)host;
- (NSString *)database;
- (NSString *)port;
- (NSString *)databaseOrPort;

- (void)setUserInfo:(NSDictionary *)dictionary;
- (NSDictionary *)userInfo;

@end
