/* FBObserverCenter.h created by ahoesch on Wed 13-Dec-2000 */

#import <Foundation/Foundation.h>
#import "FBObserving.h"

@interface FBObserverCenter : NSObject
{

}

+ (void)addObserver:(id <FBObserving>)observer forObject:(id)object;
+ (void)removeObserver:(id <FBObserving>)observer forObject:(id)object;
+ (void)removeObserver:(id <FBObserving>)observer;

+ (void)addObserver:(id <FBObserving>)observer forObjects:(NSArray *)objects;
+ (void)removeObserver:(id <FBObserving>)observer forObjects:(NSArray *)objects;

+ (NSArray *)observersForObject:(id)object;

+ (void)temporarilyDisableObservers:(NSArray *)observers forObject:(id)object;

+ (void)notifyObserversObjectWillChange:(id)object;
+ (void)notifyObserversObjectWillChange:(id)object mask:(unsigned)mask;

+ (void)notifyObserversObjectDidChange:(id)object;
+ (void)notifyObserversObjectDidChange:(id)object mask:(unsigned)mask;

+ (void)postponeNotifications;
+ (void)releaseNotifications;

@end

@interface NSNotificationCenter (NSNotificationCenterExtension)

- (void)addObserver:(id)observer selector:(SEL)selector name:(NSString *)name objects:(NSArray *)objects;
- (void)removeObserver:(id)observer name:(NSString *)name objects:(NSArray *)objects;

@end
