/* FBRelationship.h created by ahoesch on Sat 30-Sep-2000 */

#import <Foundation/Foundation.h>
#import "FBAttribute.h"

typedef enum { FBDeleteRuleNullify, FBDeleteRuleCascade, FBDeleteRuleDeny, FBDeleteRuleNoAction } FBDeleteRule;

typedef enum { FBInnerJoin, FBFullOuterJoin, FBLeftOuterJoin, FBRightOuterJoin } FBJoinSemantic;

@class FBEntity;
@class FBJoin;

@interface FBRelationship : NSObject < NSCoding >
{
    NSString *_name;
    FBEntity *_entity;
    FBEntity *_destination;
    NSMutableArray *_definitionArray;
    BOOL _isFlattened;
    BOOL _isToMany;
    NSMutableArray *_joins;
    NSDictionary *_userInfo;
    FBJoinSemantic _joinSemantic;
    FBDeleteRule _deleteRule;
    BOOL _isMandatory;
    BOOL _propagatesPrimaryKey;
    BOOL _ownsDestination;
}

- (void)setName:(NSString *)name;
- (NSString *)name;

- (void)setEntity:(FBEntity *)entity;
- (FBEntity *)entity;

- (FBEntity *)destinationEntity;

- (void)setDefinition:(NSString *)definition;
- (NSString *)definition;
- (NSArray *)definitionArray;

- (BOOL)isFlattened;

- (void)setToMany:(BOOL)yn;
- (BOOL)isToMany;

- (NSArray *)sourceAttributes;
- (FBAttribute *)sourceAttribute;
- (NSArray *)destinationAttributes;
- (FBAttribute *)destinationAttribute;

- (FBRelationship *)inverseRelationship;
- (FBRelationship *)anyInverseRelationship;

- (void)addJoin:(FBJoin *)join;
- (void)removeJoin:(FBJoin *)join;
- (NSArray *)joins;

- (void)setUserInfo:(NSDictionary *)dictionary;
- (NSDictionary *)userInfo;

- (void)setJoinSemantic:(FBJoinSemantic)joinSemantic;
- (FBJoinSemantic)joinSemantic;

- (void)setDeleteRule:(FBDeleteRule)deleteRule;
- (FBDeleteRule)deleteRule;

- (void)setIsMandatory:(BOOL)isMandatory;
- (BOOL)isMandatory;

- (void)setPropagatesPrimaryKey:(BOOL)yn;
- (BOOL)propagatesPrimaryKey;

- (void)setOwnsDestination:(BOOL)yn;
- (BOOL)ownsDestination;

- (NSDictionary *)propertyList;
- (NSArray *)joinsPropertyList;

@end
