/* FBStringExtension.h created by ahoesch on Fri 27-Apr-2001 */

#import <Foundation/Foundation.h>

@class FBObject;

@interface NSString (FBStringExtension)

+ (NSString *)stringWithContentsOfFile:(NSString *)path prepareForApache:(BOOL)flag;

+ (NSString *)stringWithCharacter:(unichar)aCharacter;
+ (NSString *)stringByChaining:(NSString *)string count:(int)count;

- (NSString *)fixPropertyListString;
- (NSString *)stringAfterRemovingFirstCharacter;
- (NSString *)stringAfterRemovingLastCharacter;
- (NSString *)stringAfterRemovingTailingLinefeed;
- (NSString *)stringAfterAddingTailingLinefeed;

- (NSString *)stringAfterRemovingLeadingCharactersInString:(NSString *)string;

- (NSString *)stringAfterRemovingLeadingCharactersFromSet:(NSCharacterSet *)set;
- (NSString *)stringAfterRemovingTailingCharactersFromSet:(NSCharacterSet *)set;
- (NSString *)stringAfterRemovingAllOccurancesFromSet:(NSCharacterSet *)set;

- (NSString *)stringAfterRemovingAllOccurancesOfString:(NSString *)search;
- (NSString *)stringAfterReplacingAllOccurancesOfString:(NSString *)search withString:(NSString *)replacement;
- (int)numberOfOccurancesOfString:(NSString *)string;

@end


@interface NSString (FBStringLatexExtension)

- (NSString *)stringFromLatexRepresentation;
- (NSString *)latexRepresentation;
- (NSString *)latexRepresentation:(BOOL)flag;
- (NSString *)stringBetweenBraces;
- (NSString *)stringBetweenBracesInRange:(NSRange *)pRange;

- (NSString *)stringAfterEmbracingUppercaseCharacters;
- (NSString *)stringAfterRemovingEmbracesFromUppercaseCharacters;

- (NSRange)rangeOfControlCharacterWithLaTeXReplacement:(NSString **)replacement range:(NSRange)limit;
- (NSRange)rangeOfUnicodeWithLaTeXReplacement:(NSString **)replacement range:(NSRange)limit text:(BOOL)flag;
- (NSString *)prefixedWithBackSlash;

@end


@interface NSString (FBStringHTMLExtension)

- (NSString *)htmlRepresentation;
- (NSRange)rangeOfControlCharacterWithHTMLReplacement:(NSString **)replacement range:(NSRange)limit;
- (NSRange)rangeOfUnicodeWithHTMLReplacement:(NSString **)replacement range:(NSRange)limit;

@end


@interface NSMutableString (NSMutableStringLatexExtension)

- (id)replaceControlCharactersForLateX;
- (id)replaceUnicodesForLaTeX;
- (id)replaceUnicodesForLaTeX:(BOOL)flag;
- (id)replaceControlCharactersForHTML;
- (id)replaceUnicodesForHTML;

@end

@interface NSString (NSStringPlaceHolderExtension)

- (NSString *)replacePlaceHolders:(NSString *)placeHolder fromObject:(FBObject *)object;
- (NSString *)replacePlaceHolders:(NSString *)placeHolder fromObject:(FBObject *)object createLaTeX:(BOOL)createLaTeX;
- (NSString *)stringAfterFillingPlaceHoldersFromObject:(FBObject *)object;
- (NSString *)stringAfterFillingPlaceHoldersFromObject:(FBObject *)object createLaTeX:(BOOL)createLaTeX;

@end
