/* FBUndoManager.h created by ahoesch on Fri 27-Oct-2000 */

#import <Foundation/Foundation.h>

@interface FBUndoOperation : NSObject
{
   id _target;
   SEL _selector;
   id _arg;
}

- (id)initWithTarget:(id)target selector:(SEL)aSelector arg:(id)anObject;
- (id)target;
- (SEL)selector;
- (id)arg;

@end

typedef enum { NORMAL, UNDOING, REDOING } UNDOMANAGER_CONDITION;

@interface FBUndoManager : NSObject
{
   NSMutableArray *_undoOperations;
   NSMutableArray *_redoOperations;
   UNDOMANAGER_CONDITION _condition; 
}

- (void)registerUndoWithTarget:(id)target selector:(SEL)aSelector arg:(id)anObject;

- (id)prepareWithInvocationTarget:(id)target;
- (void)forwardInvocation:(NSInvocation *)anInvocation;

- (BOOL)canRedo;
- (BOOL)canUndo;

- (BOOL)isRedoing;
- (BOOL)isUndoing;

- (void)redo;
- (void)undo;

- (void)forgetAll;
- (void)forgetAllWithTarget:(id)target;

@end
