/* FrontBaseTypes.h created by sb on Tue 04-Aug-1998 */

#import <Foundation/Foundation.h>

#define FB_Undecided	-1
#define	FB_PrimaryKey	0
#define	FB_Boolean	1
#define	FB_Integer	2
#define	FB_SmallInteger	3
#define	FB_Float	4
#define	FB_Real		5
#define	FB_Double	6
#define	FB_Numeric	7
#define FB_Decimal	8
#define FB_Character	9
#define FB_VCharacter	10
#define	FB_Bit		11
#define FB_VBit		12
#define FB_Date		13
#define FB_Time		14
#define FB_TimeTZ	15
#define FB_Timestamp	16
#define FB_TimestampTZ	17
#define FB_YearMonth	18
#define FB_DayTime	19
#define FB_CLOB		20
#define FB_BLOB		21

#define FBGeneralAdaptorException @"FBGeneralAdaptorException"

@interface FrontBaseTypes : NSObject

+ (BOOL)isType:(NSString *)typeA equalToType:(NSString *)typeB;

+ (int)internalTypeFor:(NSString *)externalType;
+ (NSString *)valueClassForType:(NSString *)externalType;
+ (NSArray *)externalTypes;
+ (BOOL)isValidQualifierType:(NSString *)type;
+ (BOOL)hasWidth:(NSString *)type;
+ (BOOL)hasPrecision:(NSString *)type;
+ (BOOL)hasScale:(NSString *)type;

+ (void)insertExternalName:(NSString *)name valueClass:(NSString *)class internalType:(int)type validQualifier:(BOOL)valid hasWidth:(BOOL)width hasScale:(BOOL)scale hasPrecision:(BOOL)precision;

@end
