/* FBObjectExtension.h created by ahoesch on Mon 18-Dec-2000 */

#import <Foundation/Foundation.h>
#import <FBEnterprise/FBEnterprise.h>
#import "OBClass.h"

@interface FBObject (FBObjectExtension)

- (void)setHistoryAttributeFromDic:(NSDictionary *)dic;
- (void)takeValue:(id)value forKey:(NSString *)key validFrom:(NSCalendarDate *)date;
- (id)valueForKey:(NSString *)key atTime:(NSCalendarDate *)date;
- (void)validateHistoryArray:(NSArray *)historyArray;

- (void)takeRole:(NSString *)roleName;
- (void)takeRole:(NSString *)roleName validFrom:(NSCalendarDate *)date;

- (void)discardRole:(NSString *)roleName;
- (void)discardRole:(NSString *)roleName expireAt:(NSCalendarDate *)date;

- (BOOL)hasRole:(NSString *)roleName;
- (BOOL)hasNotRole:(NSString *)roleName;
- (FBObject *)role:(NSString *)roleName atTime:(NSCalendarDate *)date;
- (FBObject *)role:(NSString *)roleName;

@end

@interface FBEntity (FBEntityRoleExtension)

- (void)setRoleMode:(ROLEMODE)mode forRole:(NSString *)rolename;
- (ROLEMODE)roleModeForRole:(NSString *)rolename;

@end
