/* OBAttribute.h created by ahoesch on Sat 18-Nov-2000 */

#import <Foundation/Foundation.h>

typedef enum { OBCategory_Attribute, OBCategory_Attributes, OBCategory_AttributesWithBack, OBCategory_Reference, OBCategory_References, OBCategory_ReferencesWithBack, OBCategory_AttachmentsWithBack, OBCategory_PossessionsWithBack, OBCategory_ManyToMany, OBCategory_History } OBAttributeCategory;

@class OBType;
@class OBModel;
@class OBClass;

@interface OBAttribute : NSObject// <NSCoding>
{
   NSString *_name;
   OBAttributeCategory _category;
   OBType *_type;
   OBClass *_role;
   BOOL _allowsNull;
   unsigned _width;
   NSString *_info;
}

- (id)initWithPropertyList:(NSDictionary *)dic model:(OBModel *)model;

- (BOOL)referencesClass:(OBClass *)aClass;

- (void)setName:(NSString *)name;
- (NSString *)name;

- (void)setCategory:(OBAttributeCategory)category;
- (OBAttributeCategory)category;

- (void)setType:(OBType *)type;
- (OBType *)type;

- (void)setRole:(OBClass *)aClass;
- (OBClass *)role;

- (void)setInfo:(NSString *)info;
- (NSString *)info;

- (void)setAllowsNull:(BOOL)flag;
- (BOOL)allowsNull;

- (void)setWidth:(unsigned)width;
- (int)width;

- (BOOL)allowsRole;
- (BOOL)allowsWidth;

- (NSDictionary *)propertyList;

@end

@interface OBAttribute (OBAttributeDisplay)

+ (NSArray *)categories;
+ (NSString *)stringForCategory:(OBAttributeCategory)category;
+ (OBAttributeCategory)categoryForString:(NSString *)string;

@end

