/* OBEntity.h created by ahoesch on Sat 18-Nov-2000 */

#import <Foundation/Foundation.h>

typedef enum { OBToOneRole, OBToManyRole } ROLEMODE;

@class OBModel;
@class OBAttribute;

@interface OBClass : NSObject// <NSCoding>
{
   NSString *_name;
   NSMutableArray *_attributes;
   NSMutableDictionary *_subClassesDic;
   NSMutableDictionary *_rolesDic;
   OBClass *_superClass; // Inheritance
   OBClass *_parentClass; // Roles
   OBModel *_model;
   ROLEMODE _roleMode;
}

- (id)initWithPropertyList:(NSDictionary *)dic postpone:(NSMutableArray *)postArray model:(OBModel *)model;

- (NSArray *)referencesForClass:(OBClass *)aClass;

- (void)setName:(NSString *)name;
- (NSString *)name;

- (void)setModel:(OBModel *)model;
- (OBModel *)model;

- (OBClass *)childWithName:(NSString *)name;
- (OBClass *)classWithPath:(NSString *)path;
- (NSString *)path;
- (void)renameChildFrom:(NSString *)oldName to:(NSString *)newName;
- (OBClass *)parent;
- (OBClass *)root;

- (void)addSubClass:(OBClass *)aClass;
- (BOOL)removeSubClass:(OBClass *)aClass;
- (BOOL)removeSubClass:(OBClass *)aClass references:(NSArray **)pReferences;
- (NSArray *)subClasses;
- (int)numberOfSubClasses;
- (void)setSuperClass:(OBClass *)aClass;
- (OBClass *)superClass;

- (void)addRole:(OBClass *)aClass;
- (BOOL)removeRole:(OBClass *)aClass;
- (BOOL)removeRole:(OBClass *)aClass references:(NSArray **)pReferences;
- (NSArray *)roles;
- (int)numberOfRoles;
- (void)setParentClass:(OBClass *)aClass;
- (OBClass *)parentClass;


- (void)addAttribute:(OBAttribute *)attribute;
- (void)removeAttribute:(OBAttribute *) attribute;
- (NSArray *)attributes;
- (int)numberOfAttributes;

- (NSDictionary *)propertyList;

- (void)setRoleMode:(ROLEMODE)mode;
- (ROLEMODE)roleMode;

@end
