/* OBModel.h created by ahoesch on Sat 18-Nov-2000 */

#import <Foundation/Foundation.h>
#import <FBEnterprise/FBEnterprise.h>
#import "OBClass.h"

@interface OBModel : NSObject// <NSCoding>
{
   NSMutableDictionary *_classesDic; // name --> OBClass
}

- (id)initWithPropertyList:(NSArray *)propertyList;
- (void)setPropertyList:(NSArray *)array;
- (NSArray *)propertyList;

- (NSArray *)referencesForClass:(OBClass *)aClass;
- (void)removeReferences:(NSArray *)references;

- (void)addClass:(OBClass *)aClass;
- (BOOL)removeClass:(OBClass *)aClass;
- (BOOL)removeClass:(OBClass *)aClass references:(NSArray **)pReferences;
- (NSArray *)classNames;
- (NSArray *)classes;
- (OBClass *)classNamed:(NSString *)name;
- (OBClass *)classWithPath:(NSString *)path;
- (void)renameClassFrom:(NSString *)oldName to:(NSString *)newName;

- (void)collectAllClasses:(NSMutableDictionary *)dic;
- (void)collectSubClasses:(NSMutableDictionary *)dic;

- (int)numberOfClasses;
- (int)numberOfClassesIncludingAllSubClasses;

@end
