/* OBType.h created by ahoesch on Mon 27-Nov-2000 */

#import <Foundation/Foundation.h>

@class OBClass;
@class OBModel;

@interface OBType : NSObject <NSCoding>
{
   NSString *_name;
   NSDictionary *_details;
   OBClass *_class;
}

+ (NSDictionary *)infoForBaseType:(NSString *)name;
+ (NSArray *)typesForModel:(OBModel *)model;
+ (OBType *)typeWithName:(NSString *)name model:(OBModel *)model;

- (id)initWithName:(NSString *)name details:(NSDictionary *)details;
- (id)initWithClass:(OBClass *)aClass;

- (NSString *)name;
- (OBClass *)destinationClass;
- (BOOL)isBaseType;
- (BOOL)isClassType;

- (BOOL)createIntermediate;

@end
