/* Bibliography.h created by ahoesch on Fri 01-Jun-2001 */

#import <AppKit/AppKit.h>
#import <FBEnterprise/FBEnterprise.h>
#import "LinkTargetProtocol.h"
#import "PresentableRootObjectProtocol.h"

@interface NSString (BibliographyExtension)

- (BOOL)isApaciteStyle;
- (BOOL)isNaturalStyle;

@end

@interface Bibliography : FBObject < LinkTargetProtocol, PresentableRootObjectProtocol >
{

}

+ (NSImage *)smallImage;

+ (unsigned int)numberOfInputTypes;
+ (NSArray *)inputTypes;
+ (NSArray *)fields;

+ (int)indexForInputType:(NSString *)string;
+ (NSString *)inputTypeAtIndex:(int)index;

+ (NSArray *)mandatoryFieldsForInputType:(NSString *)string;
+ (NSArray *)optionalFieldsForInputType:(NSString *)string;

- (NSString *)abbreviatedTitle;
- (NSString *)abbreviatedAuthors;
- (NSString *)authorLabel;
- (NSString *)yearLabel;

- (NSString *)latexRepresentation;

+ (NSString *)abbreviatedAuthorsWithString:(NSString *)string;
+ (NSString *)tableViewDescriptionForAuthor:(NSString *)author title:(NSString *)title;

@end
