/* Body.h created by ahoesch on Mon 28-May-2001 */

#import <AppKit/AppKit.h>
#import <FBEnterprise/FBEnterprise.h>
#import "LaTeXGeneratorProtocol.h"

@class CountCenter;
@class ObjectUnarchiver;
@class BodyController;

@interface Body : FBObject
{
}

- (void)setAttributedString:(NSAttributedString *)attrString;
- (NSAttributedString *)attributedString;
- (NSAttributedString *)attributedStringWithCountCenter:(CountCenter *)countCenter propertyObserver:(id)propertyObserver;
- (NSAttributedString *)attributedStringWithCountCenter:(CountCenter *)countCenter unarchiver:(ObjectUnarchiver *)coder propertyObserver:(id)propertyObserver;

- (void)setString:(NSString *)string;
- (NSString *)string;

- (FBObject *)presentableRootObject;
- (FBObject *)printableRootObject;

- (void)addPropertiesForAttributeName:(NSString *)attributeName attributedString:(NSAttributedString *)attrString;
- (void)removePropertiesForAttributeName:(NSString *)attributeName attributedString:(NSAttributedString *)attrString range:(NSRange)aRange preventDeletion:(BOOL)flag;

- (void)addLinksInAttributedString:(NSAttributedString *)attrString;
- (void)removeLinksInAttributedString:(NSAttributedString *)attrString range:(NSRange)aRange preventDeletion:(BOOL)flag;

- (void)addObjectsInAttributedString:(NSAttributedString *)attrString;
- (void)removeObjectsInAttributedString:(NSAttributedString *)attrString range:(NSRange)aRange preventDeletion:(BOOL)flag;

@end


@interface NSAttributedString (NSAttributedStringBodyExtension)

//+ (NSMutableAttributedString *)attributedStringForBody:(Body *)body countCenter:(CountCenter *)countCenter;
+ (NSMutableAttributedString *)attributedStringForBody:(Body *)body countCenter:(CountCenter *)countCenter unarchiver:(ObjectUnarchiver *)unarchiver propertyObserver:(id)propertyObserver;
+ (NSMutableAttributedString *)attributedStringForBody:(Body *)body text:(NSString *)text countCenter:(CountCenter *)countCenter unarchiver:(ObjectUnarchiver *)unarchiver propertyObserver:(id)propertyObserver;

- (NSAttributedString *)attributedStringAfterRemovingLabels;

@end

@interface NSMutableAttributedString (NSMutableAttributedStringBodyExtension)

- (void)preparePropertiesForSave:(Body *)body;

- (void)wakeUpPropertyCarriersOfClass:(Class)class inRange:(NSRange)limit unarchiver:(ObjectUnarchiver *)unarchiver propertyObserver:(id)propertyObserver;
- (void)shutdownPropertyCarriersWithAttributeName:(NSString *)attributeName inRange:(NSRange)limit;

//- (void)wakeUpLinksInRange:(NSRange)limit;
- (void)wakeUpLinksInRange:(NSRange)limit unarchiver:(ObjectUnarchiver *)unarchiver;
- (void)shutdownLinksInRange:(NSRange)limit;

- (void)removeLabelSpacesInRange:(NSRange)range charactersRemoved:(int *)pNum;

- (void)fillLabelsInRange:(NSRange)range countCenter:(CountCenter *)countCenter;

@end
