/* Book.h created by ahoesch on Tue 19-Jun-2001 */

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import <FBEnterprise/FBEnterprise.h>
#import "LinkTargetProtocol.h"
#import "PresentableRootObjectProtocol.h"
#import "InspectorPageProtocols.h"
#import "LaTeXGeneratorProtocol.h"

@class Chapter;
@class Author;

@interface Book : FBObject < LinkTargetProtocol, PresentableRootObjectProtocol, AttributesInspectorPageProtocol >
{
   Signature *_signature;
}

+ (NSImage *)smallImage;
+ (NSImage *)bigImage;

- (Chapter *)lastChapter;

- (Chapter *)frontmatter;
- (Chapter *)backmatter;
- (Chapter *)appendix;

- (void)createSignatureWithAuthor:(Author *)author;
- (void)registerModificationByUser:(Author *)author;
- (BOOL)hasDecodedSignature;
- (void)loadSignature;
- (Signature *)signatureObject;

- (NSArray *)mainMatterChapters;

- (NSString *)string;

@end
