/* EnumerateCarrier.h created by ahoesch on Sat 22-Dec-2001 */

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import "PropertyCarrierProtocol.h"
#import "LaTeXGeneratorProtocol.h"
#import "HTMLGeneratorProtocol.h"
#import "PropertyCarrier.h"

#define ITEMIZELISTKIND 0
#define ENUMERATELISTKIND 1
#define DESCRIPTIONLISTKIND 2

@interface ItemizeNode : NSObject
{
   int _kind;
   int _level;
   NSAttributedString *_attrString;
   NSArray *_children;
   int _counter;
}

- (void)setKind:(int)kind;
- (int)kind;

- (void)setLevel:(int)level;
- (int)level;

- (void)setCounter:(int)counter;
- (int)counter;

- (void)setAttributedString:(NSAttributedString *)attrString;
- (NSAttributedString *)attributedStringForIndex:(int)index;

- (void)setChildren:(NSArray *)array;
- (NSArray *)children;

- (NSString *)latexWithGenerator:(id < LaTeXGeneratorProtocol >)generator;
- (NSString *)htmlWithGenerator:(id < HTMLGeneratorProtocol >)generator;

@end

@interface EnumerateCarrier : PropertyCarrier < PropertyCarrierProtocol >
{

}

+ (NSString *)itemizeMarkerForLevel:(int)level;
+ (NSString *)enumerateMarkerForLevel:(int)level;
+ (NSString *)markerForDic:(NSDictionary *)dic;

+ (NSArray *)nodesForAttributedString:(NSAttributedString *)attrString level:(int)level;
+ (NSArray *)nodesForAttributedString:(NSAttributedString *)attrString level:(int)level itemizeCounter:(int)itemizeCounter enumeratorCounter:(int)enumeratorCounter;

+ (NSAttributedString *)attributedStringForNodes:(NSArray *)nodes;

+ (NSString *)latexReplacementForNodes:(NSArray *)nodes generator:(id < LaTeXGeneratorProtocol >)generator;
+ (NSString *)htmlReplacementForNodes:(NSArray *)nodes generator:(id < HTMLGeneratorProtocol >)generator;

- (NSString *)replacementForAttributedString:(NSAttributedString *)attrString latexGenerator:(id < LaTeXGeneratorProtocol >)generator;
- (NSString *)replacementForAttributedString:(NSAttributedString *)attrString htmlGenerator:(id < HTMLGeneratorProtocol >)generator;

@end
