/* ExpressionPart.h created by ahoesch on Sat 25-Aug-2001 */

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import "ParentPart.h"
#import "OperatorManager.h"

@interface ExpressionPart : ParentPart
{
   float _middleline;
   float _ascender;
   BOOL _hasAscender;
   NSNumber *_leftMarginToCompareSymbol;
}

- (NSSize)size;
- (void)setCursorToIndex:(int)index;

- (float)displacementBetween:(Part *)leftPart and:(Part *)rightPart;
- (float)identifierShift;
- (float)operatorShift;
- (float)relationShift;
- (BOOL)isSubPart;
- (BOOL)isTextPart;

- (BOOL)handleStroke:(SAStroke *)stroke inTextPartAtIndex:(int)index;

- (void)setMathml:(NSString *)string;
- (NSString *)mathml;

- (NSNumber *)leftMarginToCompareSymbol;

@end

@interface ApplyCarrier : NSObject
{
   Operator *_operator;
   NSMutableArray *_parameters;
}

- (id)initWithOperator:(Operator *)operator parameters:(NSArray *)parameters;
- (NSString *)mathml;

@end
