/* FigureCarrier.h created by ahoesch on Tue 03-Jul-2001 */

#import <Foundation/Foundation.h>
#import "PropertyCarrierProtocol.h"
#import "PropertyCarrier.h"

@class Figure;

@interface FigureCarrier : PropertyCarrier < PropertyCarrierProtocol >
{
   Figure *_figure;
   NSString *_placementOptions;
   NSString *_figureOptions;
   int _captionPosition;
   NSString *_captionWidth;
   int _figureBoxed;
}

- (id)initWithBody:(Body *)body fileWrapper:(NSFileWrapper *)fileWrapper;

- (void)extractAttributesFromPredecessor:(FigureCarrier *)predecessor fileWrapper:(NSFileWrapper *)fileWrapper;

- (void)setFigure:(Figure *)figure;
- (Figure *)figure;

- (void)setPlacementOptions:(NSString *)string;
- (NSString *)placementOptions;

- (void)setFigureOptions:(NSString *)string;
- (NSString *)figureOptions;

- (void)setCaptionPosition:(int)pos;
- (int)captionPosition;

- (void)setCaptionWidth:(NSString *)string;
- (NSString *)captionWidth;

- (void)setFigureBoxed:(int)value;
- (int)figureBoxed;

@end
