/* Folder.h created by ahoesch on Sat 13-Oct-2001 */

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import <FBEnterprise/FBEnterprise.h>
#import "PresentableRootObjectProtocol.h"

@class Signature;
@class Author;

@interface Folder : FBObject < PresentableRootObjectProtocol >
{
   Signature *_signature;
}

+ (NSArray *)textExtensions;
+ (BOOL)isTextExtension:(NSString *)string;

- (void)createSignatureWithAuthor:(Author *)author;
- (void)registerModificationByUser:(Author *)author;
- (BOOL)hasDecodedSignature;
- (void)loadSignature;
- (void)updateFromFileWrapper:(NSFileWrapper *)fileWrapper withPath:(NSString *)path;

@end
