/* FormulaCarrier.h created by ahoesch on Tue 08-May-2001 */

#import <AppKit/AppKit.h>
#import <SAFoundation/SAFoundation.h>
#import "PropertyCarrier.h"
#import "PropertyCarrierProtocol.h"

@class SAStroke;
@class ExpressionPart;
@class Formula;
@class FormulaCarrier;

@protocol FormulaRelayoutProtocol

- (void)relayoutFormula:(FormulaCarrier *)formulaCarrier edited:(BOOL)flag;

@end

@interface FormulaCarrier : PropertyCarrier < PropertyCarrierProtocol >
{
   ExpressionPart *_part;
   id < FormulaRelayoutProtocol > _observer;
   Formula *_formula;
   BOOL _isNumbered;
   BOOL _textFormula;
}

+ (int)numberOfSpacesToLabel;

- (void)setTextFormula:(BOOL)flag;
- (BOOL)isTextFormula;
- (BOOL)isTextPart;

- (void)setNumbered:(BOOL)flag;
- (BOOL)isNumbered;

- (void)setBorderWidth:(float)width margin:(float)margin;
- (void)setObserver:(id < FormulaRelayoutProtocol >)observer;
- (void)setFont:(NSFont *)font;

- (void)setStatus:(unsigned int)status;
- (unsigned int)status;

- (void)drawWithFrame:(NSRect)cellFrame inView:(NSView *)controlView;
- (void)drawInteriorWithFrame:(NSRect)cellFrame inView:(NSView *)controlView;

- (NSNumber *)leftMarginToCompareSymbol;
- (NSSize)size;
- (Formula *)formula;

- (BOOL)handleStroke:(SAStroke *)stroke;

- (NSNumber *)sourceKey;

- (NSString *)latexRepresentation;

@end
