/* FunctionManager.h created by ahoesch on Thu 06-Sep-2001 */

#import <Foundation/Foundation.h>

typedef enum { FCUNARY, FCBINARY, FCNARY } FCARITY;

@interface Function : NSObject
{
   NSString *_screen;
   NSString *_mathml;
   FCARITY _arity;
}

+ (id)functionWithScreen:(NSString *)screen mathml:(NSString *)mathml arity:(FCARITY)arity;
- (id)initWithScreen:(NSString *)screen mathml:(NSString *)mathml arity:(FCARITY)arity;
- (NSString *)screen;
- (NSString *)mathml;
- (FCARITY)arity;

@end

@interface FunctionCarrier : NSObject
{
   Function *_function;
   NSArray *_arguments;
}

- (id)initWithFunction:(Function *)function arguments:(NSArray *)arguments;
- (Function *)function;
- (NSArray *)arguments;

@end

@interface FunctionManager : NSObject
{
}

+ (NSArray *)functionsForString:(NSString *)string;
+ (Function *)functionForScreen:(NSString *)string;
+ (Function *)functionForMathML:(NSString *)string;

@end
