/* Link.h created by ahoesch on Fri 01-Jun-2001 */

#import <AppKit/AppKit.h>
#import <FBEnterprise/FBEnterprise.h>
#import "LaTeXGeneratorProtocol.h"
#import "HTMLGeneratorProtocol.h"

@interface Link : FBObject
{
   unsigned _form;
}

- (void)setAttributes:(NSDictionary *)attributes;
- (void)setForm:(unsigned)form;
- (unsigned)form;

// This method is supposed to replace the given range with a live representation of the property. The starting and stopping tag has already been removed when this method is called. This method is used to generate an attributed string from the database representation.
- (BOOL)awakeInRange:(NSRange)range attributedString:(NSMutableAttributedString *)attrString  textView:(NSTextView *)textView length:(int *)newLength;

// This method is supposed to replace the given range with an XML representation. This method is used by preparePropertiesForSave
- (void)shutdownInRange:(NSRange)range attributedString:(NSMutableAttributedString *)attrString length:(int *)newLength;
- (void)shutdownInRange:(NSRange)range attributedString:(NSMutableAttributedString *)attrString length:(int *)newLength primaryKey:(NSNumber *)primaryKey;

- (void)addAttributesInRange:(NSRange)range attributedString:(NSMutableAttributedString *)attrString;
//- (void)removeAttributesInRange:(NSRange)range attributedString:(NSMutableAttributedString *)attrString;

- (FBObject *)target;
- (NSColor *)color;

- (NSString *)replacementWithLatexGenerator:(id < LaTeXGeneratorProtocol >)generator;
- (NSString *)replacementWithHTMLGenerator:(id < HTMLGeneratorProtocol >)generator;

- (NSAttributedString *)attributedRepresentation;

- (NSDictionary *)typingAttributesAtIndex:(int)index textStorage:(NSTextStorage *)textStorage range:(NSRange)range typingAttributes:(NSDictionary *)dic;

- (BOOL)isBibliographyLink;

- (BOOL)removeInRange:(NSRange)range attributedString:(NSMutableAttributedString *)attrString textView:(NSTextView *)textView;

@end
