/* MathMLParser.h created by ahoesch on Fri 07-Sep-2001 */

#import <Foundation/Foundation.h>

@class Part;
@interface MathMLParser : NSObject
{

}

+ (NSArray *)partsForSequence:(NSString *)string;
+ (NSArray *)partsForTag:(NSString *)tag withContents:(NSString *)contents attributes:(NSDictionary *)attributeDic;
+ (Part *)partForSequence:(NSString *)string;
+ (Part *)partForTag:(NSString *)tag withContents:(NSString *)contents attributes:(NSDictionary *)attributes;

@end

@interface NSString (MathMLExtension)

// string: <apply toll="Yes" type="Big"><eq/><ci>y</ci><ci>a</ci></apply>
// tag: apply
// contents: <eq/><ci>y</ci><ci>a</ci>
// attributes: { toll -> YES, type -> Big }
- (NSString *)contentsForTag:(NSString **)pTag attributes:(NSDictionary **)pDic;

- (NSString *)contentsForTag:(NSString **)pTag attributes:(NSDictionary **)pDic startLocation:(unsigned)startLocation stopLocation:(unsigned *)stopLocation;

@end

@interface NSAttributedString (MathMLExtension)

- (NSAttributedString *)attributedContentsForTag:(NSString **)pTag attributes:(NSDictionary **)pDic startLocation:(unsigned)startLocation stopLocation:(unsigned *)stopLocation;

@end

