/* OperatorManager.h created by ahoesch on Tue 04-Sep-2001 */

#import <Foundation/Foundation.h>
#import "TextPart.h"

typedef enum { OPUNARY, OPBINARY, OPNARY } OPARITY;

@interface Operator : NSObject
{
   NSString *_screen;
   NSString *_mathml;
   OPARITY _arity;
}

+ (id)operatorWithScreen:(NSString *)screen mathml:(NSString *)mathml arity:(OPARITY)arity;
- (id)initWithScreen:(NSString *)screen mathml:(NSString *)mathml arity:(OPARITY)arity;
- (NSString *)screen;
- (NSString *)mathml;
- (OPARITY)arity;
- (BOOL)isRelation;

@end

@interface OperatorCarrier : NSObject
{
   Operator *_operator;
   int _operatorId;
}

- (id)initWithOperator:(Operator *)operator operatorId:(int)operatorId;
- (Operator *)operator;
- (int)operatorId;

@end

@interface OperatorManager : NSObject
{
}

+ (int)operatorIdForScreen:(NSString *)string minArity:(OPARITY)arity;
+ (int)operatorIdForScreen:(NSString *)string;
+ (Operator *)operatorForOperatorId:(int)operatorId;
+ (Operator *)operatorForMathML:(NSString *)string minArity:(OPARITY)arity;

@end
