/* ParentPart.h created by ahoesch on Sat 01-Sep-2001 */

#import <Foundation/Foundation.h>
#import "Part.h"

@interface ParentPart : Part
{
   NSMutableArray *_parts;
   NSMutableArray *_rects;
   int _currentIndex;
}

- (BOOL)isEmpty;

- (void)setParts:(NSArray *)array;
- (void)removeAllParts;
- (void)appendPart:(Part *)part;
- (void)insertPart:(Part *)part atIndex:(int)index;
- (void)removeLastPart;
- (void)removePartAtIndex:(int)index;
- (void)removePart:(Part *)part;
- (void)replacePart:(Part *)oldPart withPart:(Part *)newPart;
- (void)replacePartAtIndex:(int)index withPart:(Part *)part;
- (void)replacePartsInRange:(NSRange)range withPart:(Part *)part;
- (BOOL)activatePartAtIndex:(int)index fromLeft:(BOOL)flag deep:(BOOL)deep;
- (Part *)activePart;
- (Part *)partAtIndex:(int)index;
- (short)numberOfParts;

- (void)activatePart:(Part *)part;
- (void)deactivatePart:(Part *)part;

- (NSDictionary *)suggestedVectorSublines;
- (void)useVectorSublines:(NSDictionary *)sublines;

@end
