/* Part.h created by ahoesch on Mon 27-Aug-2001 */

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

typedef enum { DEACTIVATED, CACTIVATED, PACTIVATED, SACTIVATED, LFOCUSED, RFOCUSED } SELSTATUS;
typedef enum { PKUNKNOWN, PKIDENTIFIER, PKNUMBER, PKFUNCTION, PKOPERATOR, PKNAME } PARTKIND;

#define PartModifiedNotification @"PartModifiedNotification"

@class SAStroke;

@interface Part : NSObject
{
   SELSTATUS _status;
   NSSize _size;
   BOOL _sizeValid;
   short _level;
   PARTKIND _kind;
   BOOL _sendNotificationRequest;
   BOOL _isTextFormula;
   float _fontSize;
}

- (BOOL)isSizeValid;
- (void)invalidateSize;
- (void)validateSize;

- (void)setSize:(NSSize)size;
- (NSSize)size;

- (void)setTextFormula:(BOOL)flag;
- (BOOL)isTextFormula;

- (void)setLevel:(short)level;
- (short)level;

- (void)setStatus:(SELSTATUS)status;
- (SELSTATUS)status;
- (BOOL)isFocused;

- (float)middleline;
- (float)ascender;
- (BOOL)hasAscender;
- (float)baselineOffset;
- (float)capHeight;
- (BOOL)hasCapHeight;

- (void)upgrade;
- (void)downgrade;

- (void)setKind:(PARTKIND)kind;
- (PARTKIND)kind;
- (NSString *)mathml;

- (BOOL)activateFromLeft:(BOOL)fromLeft deep:(BOOL)deep;
- (void)activate;
- (void)deactivate;
- (void)partModified:(BOOL)flag;

- (void)setFontSize:(float)value;
- (float)fontSize;
- (float)defaultFontSize;
- (NSFont *)symbolFont;

- (void)drawBackground:(NSRect)cellFrame inView:(NSView *)controlView;
- (void)drawDashedFrame:(NSRect)cellFrame inView:(NSView *)controlView;
- (void)drawWithFrame:(NSRect)cellFrame inView:(NSView *)controlView;

- (BOOL)handleStroke:(SAStroke *)stroke;

- (NSString *)latexRepresentation;

@end
