/* SAStroke.h created by ahoesch on Wed 01-Apr-1998 */

#import <AppKit/AppKit.h>

@interface SAStroke : NSObject
{
   unichar strokecode;
   NSString *fontName;
   NSString *fontSize;
   NSArray *parameters;
}

+ (id)strokeWithUnicode:(unichar)aChar;
+ (id)strokeWithUnicode:(unichar)aChar parameters:(NSArray *)aArray;
+ (id)strokeWithUnicode:(unichar)aChar fontName:(NSString *)aFontName fontSize:(NSString *)aFontSize;

- (id)initWithUnicode:(unichar)aChar parameters:(NSArray *)aArray;
- (id)initWithUnicode:(unichar)aChar fontName:(NSString *)aFontName fontSize:(NSString *)aFontSize;

- (NSString *)string;
- (unichar)strokecode;
- (NSString *)fontName;
- (float)fontSize;
- (id)parameterAtIndex:(int)aIndex;
- (NSArray *)parameters;
- (BOOL)isPrintable;
- (BOOL)isDecimalDigit;
- (BOOL)isAllowedInNumber;
- (BOOL)isAllowedInIdentifier;
- (BOOL)isOperator;

+ (BOOL)isCarriageReturn:(NSString *)aString;

+ (BOOL)isCursorUp:(NSString *)aString;
+ (BOOL)isCursorDown:(NSString *)aString;

/*- (BOOL)isValidSchemeStroke;
+ (BOOL)isEscape:(NSString *)aString;
+ (BOOL)isDelete:(NSString *)aString;
+ (BOOL)isBackspace:(NSString *)aString;

+ (BOOL)isCursorLeft:(NSString *)aString;
+ (BOOL)isCursorRight:(NSString *)aString;
+ (BOOL)isCursorKey:(NSString *)aString;*/

- (unichar)strokecode;

@end
