/* Section.h created by ahoesch on Tue 01-May-2001 */

#import <FBEnterprise/FBEnterprise.h>
#import "Body.h"
#import "LinkTargetProtocol.h"
#import "PresentableRootObjectProtocol.h"
#import "LaTeXGeneratorProtocol.h"

@class Document;

@interface Section : FBObject < LinkTargetProtocol, PresentableRootObjectProtocol >
{
}

+ (NSImage *)smallImage;
+ (NSImage *)bigImage;

- (NSString *)latexRepresentationWithLaTeXGenerator:(id < LaTeXGeneratorProtocol >)generator;
- (NSAttributedString *)attributedStringForLevel:(unsigned int)level includeTitle:(BOOL)flag propertyObserver:(id)propertyObserver;

- (void)appendSubsections:(NSArray *)array;

- (BOOL)raise;
- (BOOL)lower;

- (void)refreshSortIndexes;
//- (void)refreshSortIndexesStartingAt:(int)startValue;
- (void)makeRoomForNumberOfToBeInsertedItems:(int)anzal afterItemWithSortIndex:(NSNumber *)preIndex;
- (Section *)predecessor;

- (NSString *)string;

- (Document *)document;
- (BOOL)hasBibliographyReferences;
- (unsigned int)levelWithRespectToOwner:(Section *)owner;

@end
