/* Signature.h created by ahoesch on Wed 27-Jun-2001 */

#import <Foundation/Foundation.h>

@interface Author : NSObject
{
   NSString *_name;
   NSString *_organization;
   NSString *_thanks;
   NSString *_address;
}

+ (id)authorWithName:(NSString *)name organization:(NSString *)organization;

- (id)initWithPropertyList:(id)propertyList;
- (id)initWithName:(NSString *)name organization:(NSString *)organization;
- (id)propertyList;

- (NSString *)name;

- (void)setOrganization:(NSString *)string;
- (NSString *)organization;

- (void)setThanks:(NSString *)string;
- (NSString *)thanks;

- (void)setAddress:(NSString *)string;
- (NSString *)address;

@end



@interface Modification : NSObject
{
   int _authorId;
   NSCalendarDate *_date;
}

+ (id)modificationWithAuthorId:(int)authorId date:(NSCalendarDate *)date;
- (id)initWithAuthorId:(int)authorId date:(NSCalendarDate *)date;

- (id)initWithPropertyList:(id)propertyList;
- (id)propertyList;

- (int)authorId;
- (NSCalendarDate *)date;

@end


@interface Signature : NSObject
{
   NSMutableArray *_authors;
   NSMutableArray *_modifications;
}

- (id)initWithSerializedRepresentation:(NSData *)data;
- (NSData *)serializedRepresentation;

- (id)initWithPropertyList:(id)propertyList;
- (id)propertyList;

- (id)initWithAuthor:(Author *)author;

- (void)registerModificationByUser:(Author *)author;

- (Author *)author;
- (NSArray *)modifications;

- (NSArray *)authors;
- (void)addAuthor:(Author *)author;
- (void)removeAuthor:(Author *)author;
- (void)removeAuthorAtIndex:(int)index;

@end
