/* TextPart.h created by ahoesch on Sat 25-Aug-2001 */

#import <Foundation/Foundation.h>
#import "Part.h"

@class SAStroke;
@class Operator;

@interface TextPart : Part
{
   NSMutableString *_contents;
   NSMutableDictionary *_attributes;
   int _currentIndex;
   BOOL _presentation;
   BOOL _vector;
   NSRect _baseRect;
   NSMutableArray *_glyphObjects;
   float _ascender;
}

//+ (float)halfPlusHeightForLevel:(int)level;

- (float)extensionShift;

- (BOOL)vector;
- (BOOL)isEmpty;
- (BOOL)multipleCharactersAllowed;
- (BOOL)leftAndRightMarginCActivatable;

- (void)setContents:(NSString *)string;
- (NSString *)contents;
- (Operator *)operator;
- (float)ascender;
- (NSFont *)font;

- (void)setCursorToIndex:(int)index;

- (void)updateAttributes;
- (BOOL)handleStroke:(SAStroke *)stroke;
- (BOOL)handleStroke:(SAStroke *)stroke atIndex:(int)index;

- (BOOL)enterFromLeft:(BOOL)fromLeft deep:(BOOL)deep;

- (NSString *)mathml;

- (void)setPresentation:(BOOL)flag;
- (BOOL)isPresentation;

- (void)setVector:(BOOL)flag;
- (BOOL)isVector;

@end

@interface NSMutableAttributedString (TextPartExtension)

- (void)updateAttributesForPart:(TextPart *)textPart;

@end